<?php
if(!function_exists('sql_table'))	{
	function sql_table($name) {	return 'nucleus_'.$name;	}
}
class NP_Word extends NucleusPlugin {
	function getName() { return 'Word';	}
	function getAuthor() { return 'jun'; }
	function getURL() { return 'http://feles.jp/bb/viewtopic.php?t=747';	}
	function getVersion() { return '1.231';	}
	function getDescription() { return '入力補助・ハイライト表示プラグイン';	}
	function supportsFeature($what) {
		switch($what)	{
			case 'SqlTablePrefix':
				return 1;
			default:
				return 0;
		}
	}

	function getEventList() { return array('PreItem'); }
	function event_PreItem(&$data) {
		$this -> currentItem = &$data['item']; 
		$this -> convert_serchword($this -> currentItem -> body); 
		if($this -> currentItem -> more) {
			$this -> convert_serchword($this -> currentItem -> more); 
		}
	}

	function convert_serchword(&$text) {
		global $CONF;

//「<>&」変換。bodyとmoreで一回ずつしか使えない。
		if(preg_match_all('/「「「.*」」」/s', $text, $sword)) {
			foreach($sword as $dummy => $sword1) {
				foreach($sword1 as $sword2) {
					$sword3 = htmlspecialchars($sword2);
					$sword3 = ereg_replace('「「「|」」」|&lt;br /&gt;', '', $sword3);
					$sword3 = preg_replace('/\n/', '<br />', $sword3);
					$text = str_replace($sword2, $sword3, $text);
				}
			}
		}

//「<>&」変換。一行内で「」と「」に挟まれた部分を変換。何度でも使える。
		if(preg_match_all('/「」.*「」/', $text, $sword)) {
			foreach($sword as $dummy => $sword1) {
				foreach($sword1 as $sword2) {
					$sword3 = htmlspecialchars($sword2);
					$sword3 = ereg_replace('「」|「「「|」」」|&lt;br /&gt;', '', $sword3);
					$sword3 = preg_replace('/\n/', '<br />', $sword3);
					$text = str_replace($sword2, $sword3, $text);
				}
			}
		}

// 「＠＠」[@@] サイト内語句検索。
		if(preg_match_all('/「＠.*＠」|\[@.*@\]/i', $text, $sword)) {
			foreach($sword as $dummy => $sword1) {
				foreach($sword1 as $sword2) {
					$sword3 = ereg_replace('「＠|＠」|\[@|@\]', '', $sword2);
					$sword4 = '<a href="'.$CONF['IndexURL'].'?query='.urlencode($sword3).'&amp;blogid=1">'.$sword3.'</a>';
					$text = str_replace($sword2, $sword4, $text);
				}
			}
		}

// [[サイト名]サイト説明]http:// ＵＲＬ短縮変換。
		$text = preg_replace("/(\[\[)(.*)(\])(.*)(\])(https?|ftp)(:\/\/[[:alnum:]\+\$\;\?\.%,!#~*\/:@&=_-]+)/", "<a href=\"\\6\\7\" title=\"\\4\">\\2</a>", $text);

// ＵＲＬ変換。<>&変換内でも使える。
		$uri_p = "/[^=\"](https?|ftp)(:\/\/[[:alnum:]\+\$\;\?\.%,!#~*\/:@&=_-]+)/ei";
		$uri_r = "'<a href=\"\\1\\2\" title=\"\\1\\2\" target=\"_blank\">\\1'.substr('\\2' ,0 ,15).'...</a>'";
		$text = preg_replace($uri_p, $uri_r, $text);

// ;4 <div>変換。
		$text = preg_replace('/\;{4}/m', '</div>', $text);
		$text = preg_replace('/\;{3}(.*)\;/m', '<div class="\\1">', $text);

// ;3 <strong>変換。
		$text = preg_replace('/\;{3}/m', '</strong>', $text);
		$text = preg_replace('/\;{2}(.*)\;/m', '<strong class="\\1">', $text);

// ^4 <span>変換。
		$text = preg_replace('/\^{4}/m', '</span>', $text);
		$text = preg_replace('/\^{3}(.*)\^/m', '<span class="\\1">', $text);

// ^2 <table><tr><td>変換。
		$text = preg_replace('/^\^{2}t/m', '<table><tr>', $text);
		$text = preg_replace('/^\^{2}\//m', '</tr></table>', $text);
		$text = preg_replace('/^\^{2}/m', '</tr><tr>', $text);
		$text = preg_replace('/^\^(.*)\^(.*)/m', '<td class="\\1">\\2</td>', $text);
		$text = preg_replace('/^\^(.*)/m', '<td>\\1</td>', $text);
		$text = ereg_replace("<tr><br \/>", "<tr>", $text);

// * <h1>～<h6>変換。
		for($num = 6; $num >= 1; $num--) {
			$text = preg_replace('/(^|<br \/>)\*{'.$num.'}(.*)/m', '<h'.$num.'>\\2</h'.$num.'>', $text);
		}

// + <ol> - <ul> <li>４階層変換。
		for($num = 4; $num >= 1; $num--) {
			$a_ol = str_repeat('<ol>',$num);
			$b_ol = str_repeat('</ol>',$num);
			$c_ol = str_repeat('<\/ol>',$num);
			$a_ul = str_repeat('<ul>',$num);
			$b_ul = str_repeat('</ul>',$num);
			$c_ul = str_repeat('<\/ul>',$num);
			$text = preg_replace('/(^|<br \/>)\+{'.$num.'}(.*)/m', $a_ol.'<li>\\2</li>'.$b_ol, $text);
			$text = preg_replace('/(^|<br \/>)\-{'.$num.'}(.*)/m', $a_ul.'<li>\\2</li>'.$b_ul, $text);
			$text = preg_replace('/('.$c_ol.'\n'.$a_ol.'|'.$c_ul.'\n'.$a_ul.')/m', '', $text);
		}

// 語句(URL)一括変換
		$text = str_replace('nucleus.fel-is.info', 'feles.jp', $text);
		$text = str_replace('feles.jp/bb', 'japan.nucleuscms.org/bb', $text);
		$text = str_replace('vivian.stripper.jp', 'reverb.jp/vivian', $text);

// MultiBlogsキーワード変換。<>&変換内でも使える。
		$text = ereg_replace("\[\-.*\-\]", "", $text);

// タブ変換。<>&変換内でも使える。
		$text = preg_replace('/\t/', ' ', $text);

// ,, プラグイン機能を抑制。
		$text = preg_replace('/^,,(.*)/m', '\\1', $text);
	}

	function doTemplateVar(&$item, $mode = '', $what = '') {
		global $memberid, $CONF, $DIR_MEDIA;
		$itemid = $item -> itemid;
		if($mode == 't') {
			$data = $item -> title;
		}elseif($mode == 'b') {
			$data = $item -> body;
		}elseif($mode == 'm') {
			$data = $item -> more;
		}elseif($mode == 'link') {
			$link = createItemLink($itemid);
		}else {
			$data = $item -> body.$item -> more;
		}
// <%image%><%media%><%popup%>変換
		$med = requestVar('collection');
		if(!$med || !@is_dir($DIR_MEDIA.$med)) $med = $memberid;
		$text = preg_replace('/<\%image\((.*\/)(.*)\|(.*)\|(.*)\|(.*)\)\%>/', '<img src="'.$CONF['MediaURL'].'/\\1\\2" width="\\3" height="\\4" alt="\\5" />', $text);
		$text = preg_replace('/<\%image\((.*)\|(.*)\|(.*)\|(.*)\)\%>/', '<img src="'.$CONF['MediaURL'].$med.'/\\1" width="\\2" height="\\3" alt="\\4" />', $text);
		$text = preg_replace('/<\%media\((.*)\|(.*)\)\%>/', '<a href="'.$CONF['MediaURL'].$med.'/\\1">\\2</a>', $text);
		$text = preg_replace('/<\%popup\((.*)\|(.*)\|(.*)\|(.*)\)\%>/', '<a href="'.$CONF['IndexURL'].'?imagepopup='.$med.'/\\1&#38;width=\\2&#38;height=\\3&#38;imagetext=\\4">\\4</a>', $text);
		if($what) $data = htmlspecialchars(strip_tags($data));
		$uri = ($_GET['query']) ? $_GET['query'] : $_GET['que'];
		if($uri) {
			$post = urldecode($uri);
			$post = mb_convert_encoding($post, _CHARSET, 'auto');
			$post = mb_convert_kana($post, 's');
			$post = ereg_replace('[\\]+','\\',$post);
			$post = ereg_replace('[_%]+','\\0',$post);
			$post = ereg_replace('[[:space:]]+',' ',$post);
			$post_p = array('/\./','/\$/', '/\(/', '/\)/', '/\//', '/\[/', '/\]/', '/\*/', '/\+/', '/\?/', '/\|/', '/\^/');
			$post_r = array('&#46;', '&#36;', '&#40;', '&#41;', '&#47;', '&#91;', '&#93;', '&#42;', '&#43;', '&#63;', '&#124;', '&#94;');
			$post = preg_replace($post_p, $post_r, $post);
			if($mode == 'link') echo $link.'&amp;query='.$post;
			$post = explode(' ', htmlspecialchars(trim($post)));
			if($what && preg_match("/.*($post[0]).*/si" , $data, $arr_data)) {
				if($mode == 't') {
					$data = shorten($arr_data[0], $what, '...');
				}else {
					$num = mb_strpos($arr_data[0], $post[0]);
					$num = ($num <= 30) ? $num : $num - 30 ;
					$data = '...'.mb_strimwidth($arr_data[0], $num, $what, '...');
				}
			}elseif($what) {
				$data = shorten($data, $what, '...');
			}
		}elseif($what) {
			$data = shorten($data, $what, '...');
		}elseif($mode == 'link') {
			echo $link;
		}
		echo highlight($data, $post, '<strong class="highlight">\0</strong>');
	}

	function doTemplateCommentsVar(&$item, &$comment) {
		$data = $comment['body'];
		$uri = ($_GET['query']) ? $_GET['query'] : $_GET['que'];
		if($uri) {
			$post = urldecode($uri);
			$post = mb_convert_encoding($post, _CHARSET, 'auto');
			$post = mb_convert_kana($post, 's');
			$post = ereg_replace('[\\]+','\\',$post);
			$post = ereg_replace('[_%]+','\\0',$post);
			$post = ereg_replace('[[:space:]]+',' ',$post);
			$post_p = array('/\./','/\$/', '/\(/', '/\)/', '/\//', '/\[/', '/\]/', '/\*/', '/\+/', '/\?/', '/\|/', '/\^/');
			$post_r = array('&#46;', '&#36;', '&#40;', '&#41;', '&#47;', '&#91;', '&#93;', '&#42;', '&#43;', '&#63;', '&#124;', '&#94;');
			$post = preg_replace($post_p, $post_r, $post);
			$post = explode(' ', htmlspecialchars(trim($post)));
		}
		echo highlight($data, $post, '<strong class="highlight">\0</strong>');
	}
}
?>